class NP_Tree
{
   NP_Node **nodes;

   NP_File file;
   NP_Stringarray array;
   
   char *home, error_message[ 1024 ];

   int total_nodes, total_groups,
      total_messages, total_unseen, total_requested, total_headers;

   read_groups( char * );
   update_folders();
   create_folders( char * );

 public:

   NP_Tree();
   ~NP_Tree();

   clear();
   update();

   get_totals( int *, int *, int *, int *, int *, int * );
   get_node_stats( char *, int *, int *, int *, int *, int * );
   get_group_stats( char *, char *, int *, int *, int *, int * );

   get_nodes( NP_Stringarray& );
   get_groups( char *, NP_Stringarray& );

   char *operator[]( int );
   operator[]( char * );
   get_group_index( char *, char * );
   
   update_node( char * );
   update_group( char *, char * );

   void print_error() { fprintf( stderr, "%s\n", error_message ); };
   char *get_error() { return error_message; };
};


   
   
