#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "npfile.h"
#include "npgroup.h"

NP_Group::NP_Group( char *address, char *appellation )
{
   if (( home = getenv( "HOME" )) == NULL )
   {
      printf( "HOME environment variable not set!\n" );
      exit( 1 );
   }
   
   if ( address == NULL )
   {
      strcpy( error_message, "NP_Group: NP_Group(): NULL address passed as "
              "argument." );
      return;
   }

   if ( appellation == NULL )
   {
      strcpy( error_message, "NP_Group: NP_Group(): NULL group name passed "
              "as argument." );
      return;
   }
   
   if (( server = strdup( address )) == NULL )
   {
      perror( "strdup" );
      exit( 1 );
   }

   if (( name = strdup( appellation )) == NULL )
   {
      perror( "strdup" );
      exit( 1 );
   }
   
   total = requested = unseen = headers = 0;

   update();
   
   return;
}

