#include <stdlib.h>
#include <stdio.h>

#include "npfile.h"
#include "npstringarray.h"
#include "npsubscription.h"

int NP_Subscription::clear_server( int i )
{
   if ( i < 0 || i >= total )
   {
      snprintf( error_message, sizeof error_message, "NP_Subscription: "
                "clear_server(): server index %d out of range.", i );
      return 1;
   }

   if ( group_list[ i ].group_names->clear())
   {
      snprintf( error_message, sizeof error_message, "NP_Subscription: "
                " clear_server(): %s",
                group_list[ i ].group_names->get_error() );
      return 1;
   }

   if ( group_list[ i ].article_nos->clear())
   {
      snprintf( error_message, sizeof error_message, "NP_Subscription: "
                " clear_server(): %s",
                group_list[ i ].article_nos->get_error() );
      return 1;
   }
   
   return 0;
}
