#include <signal.h>
#include <unistd.h>
#include <errno.h>

#include "npconfig.h"

void NP_Config::set_size()
{
   char buffer[ 1024 ];
   snprintf( buffer, sizeof buffer, "%s/.npconfig:size", home );

   FILE *file;
   if (( file = fopen( buffer, "r" )) == NULL )
      if ( errno != ENOENT )
      {
         perror( "fopen" );
         exit( 1 );
      }
      else
      {
         gtk_window_set_default_size( GTK_WINDOW( window ), 400, 450 );
         return;
      }

   fgets( buffer, sizeof buffer, file );
   int width = atoi( buffer );
   fgets( buffer, sizeof buffer, file );
   int height = atoi( buffer );
   
   fgets( buffer, sizeof buffer, file );
   int x = atoi( buffer );
   fgets( buffer, sizeof buffer, file );
   int y = atoi( buffer );

   fclose( file );

   gtk_window_set_default_size( GTK_WINDOW( window ), width, height );
   gtk_widget_set_uposition( window, x, y );

   return;
}
