#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

#include <gtk/gtk.h>

class NP_Text
{
   GtkStyle *from_style, *date_style, *subject_style, *text_style;

   GtkWidget *window, *text_widget, *subject_label,
      *from_label, *date_label, *message_window, *cancel_button,
      *supersede_button, *edit_button, *reply_button, *follow_up_button,
      *both_button, *menu, *font_button, *first_item, *second_item,
      *third_item, *fourth_item, *fifth_item, *sixth_item, *item;

   char *server, *group, *home, *text;

   long offset, size;

   pid_t compose_pid;
   
   int requested, header, header_shown, reading, line, input_id;

   FILE *input;
   
	void set_size();
	void save_size();

   update();
   void iso8859_1_headers();
   void iso8859_1_body();
   void iso8859_1();
   void show_message( char * );
   
 public:

   NP_Text( int *, char *** );
   ~NP_Text();

   friend void answer_buttons_callback( GtkWidget *, gpointer );
   friend void show_header_button_callback( GtkWidget *, gpointer );

   friend void message_callback( GtkWidget *, gpointer );
   friend void input_callback( gpointer, gint, GdkInputCondition );

   friend void export_callback( GtkWidget *, gpointer );
   friend void export_buttons_callback( GtkWidget *, gpointer );

   friend void SIGCHLD_handler( int );   
   friend void SIGUSR1_handler( int );
   friend void SIGUSR2_handler( int );

   friend void close_button_callback( GtkWidget *, gpointer );

   friend int fonts_button_callback( GtkWidget *, GdkEvent * );
   friend void font_menu_callback( GtkWidget *, gpointer );
   
   void run();
};

void SIGTERM_handler( int );

